/*********** NOTE ************
 * by S. Dreher 2006
 *
 * This Code is partly inspired by the GMail notifier extension by Doron Rosenberg
 * and the Forecastfox extension by Jon Stritar <jstritar@MIT.EDU>.
 * Parts of these sources have been used here under the terms of the GPL
 * (GNU General Public Licence) in compliance with the License information
 * included in the original Sources.
 *
 * ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Home Status Notifier code.
 *
 * The Initial Developer of the Original Code is
 * S. Dreher (Zapp).
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either of the GNU General Public License Version 2 or later (the "GPL"),
 * or the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */
 
// Log errors in chrome file to the Javascript Console
//user_pref( "javascript.options.showInConsole", true);
//javascript.options.showInConsole = true;
// Disable XUL cache, so chrome changes do not require a restart
//user_pref( "nglayout.debug.disable_xul_cache", true);
//nglayout.debug.disable_xul_cache = true;
// dump() function outputs to console if application started with -console flag
//user_pref( "browser.dom.window.dump.enabled", true);
//browser.dom.window.dump.enabled = true;
// Enable strict javascript warnings, to produce clean extensions
//user_pref( "javascript.options.strict", true);
//javascript.options.strict = true;

var wm_prefs;

wm_prefs = new hc_preferences();
wm_prefs.initPrefs();

// Add a preferences Observers
var PrefChangeObserver = {
  observe: function(aSubject, aTopic, aData)
  {
	//alert("Pref changed: aSubject: " + aSubject + " - aTopic: " + aTopic + " - aData: " + aData);
    preferencesChanged(aData);
  }
};
wm_prefs.addObserver("homecontrol", PrefChangeObserver);

/**
 * Opens the IPS Home Control Page into the browser, depending on the preference value:
 * 0 - current tab
 * 1 - new tab
 * 2 - new window 
 * 3 - new unfocused tab
 *
 * @param aOverride - force a certain load method
 */
function login(aEvent) {	// aEvent
	//alert("Event button: " + aEvent.button);
	// on Windows, a right-click calls this method
	if (aEvent) {
		if (aEvent.button == 0) {
			setNewCalls(false);
			loadWebpage(1);
		} else if (aEvent.button == 2) {
			loadPrefWindow();
		} else {
			return;
		}
	}	
}
 
function loadWebpage(aOverride) {

  var url = wm_prefs.getCharPref(wm_prefs.PREF_SHORTCUT_URL);

  //alert("Shortcut URL:(" + url + ")");
  if (url != null) {
   
  	//url = "http://" + url;

  	// where to load the webmail into
  	//var location = aOverride ? aOverride : this.wm_prefs.getIntPref(this.wm_prefs.PREF_LOAD_LOCATION);
  	var location = aOverride;

  	if (location == 2) {
    	window.open(url);
  	} else if ((location == 1) || (location == 3)) {
    	var myTab = getBrowser().addTab(url, null, null);

    	// focus tab only if location is 1
    	if (location == 1)
      		getBrowser().selectedTab = myTab;
  	} else {
    	getBrowser().loadURI(url);
  	}
  } else {
	   alert("Home Control Notifier: \n Shortcut URL not defined. Open the Preferences dialog with a right-click on the Status Bar Icon and set the shortcut URL");
  }
}

// From gm-notifier
function loadPrefWindow() {
  window.openDialog("chrome://homecontrol/content/hc-preferences.xul", "_blank", "centerscreen,chrome,resizable=no,dependent=yes")
}

function enableCalls(aValue) {
	if (document.getElementById("callsButton")) {
      document.getElementById("callsButton").setAttribute("is-calls", aValue ? "true" : "false");
    }
}

function setNewCalls(aValue) {
  //alert("Set New Calls " + aValue ? "true" : "false" + " - in function");
  if (document.getElementById("callsButton")) {
      document.getElementById("callsButton").setAttribute("new-calls", aValue ? "true" : "false");
  }
}

function updateHeaterPosition(aElementId, aValue, szLowBattery, szWindowOpen) {
	if (aValue == 0)
    	setHeaterPosition(aElementId, "0", szLowBattery, szWindowOpen);
    if (aValue > 0 && aValue <= 25)
        setHeaterPosition(aElementId, "25", szLowBattery, szWindowOpen);
    if (aValue > 25 && aValue <= 50)
        setHeaterPosition(aElementId, "50", szLowBattery, szWindowOpen);
    if (aValue > 50 && aValue <= 75)
        setHeaterPosition(aElementId, "75", szLowBattery, szWindowOpen);
    if (aValue > 75 && aValue <= 100)
        setHeaterPosition(aElementId, "100", szLowBattery, szWindowOpen);
}

function setHeaterPosition(aElementId, aValue, szLowBattery, szWindowOpen) {
  //alert("Set New Calls " + aValue ? "true" : "false" + " - in function");
  if (document.getElementById(aElementId)) {
      document.getElementById(aElementId).setAttribute("position", aValue);
      //alert("LowBattery: " + szLowBattery);
      if (szLowBattery == " 1" || szLowBattery == "1") {
	      document.getElementById(aElementId).setAttribute("low_battery", "true");
      } else {
	      document.getElementById(aElementId).setAttribute("low_battery", "false");
      }
      if (szWindowOpen == " 1" || szWindowOpen == "1") {
	      document.getElementById(aElementId).setAttribute("open", "true");
      } else {
	      document.getElementById(aElementId).setAttribute("open", "false");
      }
  }
  else
  {
	  alert("HS-Notifier - setHeaterPosition: Element " + aElementId + "could not be retrieved");
  }
}

function updateMoistureValue(aElementId, aValue) {
	if (aValue >= 0 && aValue <= 25)
        setMoistureValue(aElementId, "25");
    if (aValue > 25 && aValue <= 50)
        setMoistureValue(aElementId, "50");
    if (aValue > 50 && aValue <= 75)
        setMoistureValue(aElementId, "75");
    if (aValue > 75 && aValue <= 100)
        setMoistureValue(aElementId, "100");	
}

function setMoistureValue(aElementId, aValue) {
  //alert("Set New Calls " + aValue ? "true" : "false" + " - in function");
  if (document.getElementById(aElementId)) {
      document.getElementById(aElementId).setAttribute("moisture", aValue);
  }
  else
  {
	  alert("HS-Notifier - setMoistureValue: Element " + aElementId + "could not be retrieved");
  }
}

function checkModuleType(aItem) {
	var aTitle = aItem.getElementsByTagName("title");
	var szName = aTitle[0].firstChild.nodeValue;
    var aName = szName.split(":");
    return aName[0];
}

function parseRSSXMLFHT(aItem, aElementId) {
	var aTitle = aItem.getElementsByTagName("title");
    var aDescriptions = aItem.getElementsByTagName("description");
    var aDate = aItem.getElementsByTagName("pubDate");
         
    var szName = aTitle[0].firstChild.nodeValue;
    var aName = szName.split(":");
    
    var szDesc = aDescriptions[0].firstChild.nodeValue;
    // Decode Blowfish encrypted content
    //var szDescDecoded = decode(szDesc);
    //alert("Decoded description: " + szDescDecoded);
    var aDesc = szDesc.split("|");

    var szTemp = aDesc[0];
    var aTemp = szTemp.split(":");
    var szTemperature = aTemp[1];

	var szTgt = aDesc[1];
    var aTarget = szTgt.split(":");
    var szTarget = aTarget[1];

	var szPos = aDesc[2];
    var aPos = szPos.split(":");
    var szPosition = aPos[1];
    
    var szMod = aDesc[3];
    var aMod = szMod.split(":");
    var szModeInt = aMod[1];
    var szMode; 
    
    switch(szModeInt) {
	    case " 0":
	     szMode = "Auto";
	     break;
	    case " 1":
	     szMode = "Manual";
	     break;
    	case " 2":
    	 szMode = "Urlaub";
    	 break;
    	case " 3":
    	 szMode = "Party";
    	 break;
    	default:
    	 szMode = "Unknown";
    	 break;
	 }

    
    var szLB = aDesc[4];
    var aLB = szLB.split(":");
    var szLowBattery = aLB[1];
    
    var szWO = aDesc[5];
    var aWO = szWO.split(":");
    var szWindowOpen = aWO[1];

    var update = aDate[0].firstChild.nodeValue;
    var tooltipstring = "Last Updated: " + update + "\n Heater Position: " + szPosition + " %"; // + ": " + aDesc[3];

    //document.getElementById('my-panel-Salon').label = name + ": " + temperature + "/" + target; // innerText
    if (document.getElementById(aElementId)) {
	    if (document.getElementById(aElementId).collapsed == true)
	    	document.getElementById(aElementId).collapsed = false;	// make the element appear
      	document.getElementById(aElementId).setAttribute("label", aName[1] + ": " + szTemperature + "/" + szTarget);
      	//document.getElementById(aElementId).tooltipText = tooltipstring;
      	// Fill the tooltip
      	//document.getElementById("hc-notifier-tooltip-title").setAttribute("value", "FHT " + aName[1]);
      	//document.getElementById("hc-notifier-tooltip-temperature").setAttribute("value", szTemperature);
      	//document.getElementById("hc-notifier-tooltip-target").setAttribute("value", szTarget);
      	//document.getElementById("hc-notifier-tooltip-position").setAttribute("value", szPosition + " %");
      	// Other method
      	if (document.getElementById(aElementId).hasAttribute("tooltip")) {
			var tooltip = document.getElementById(document.getElementById(aElementId).getAttribute("tooltip"));
			//alert("I am in and did it");
    		//tooltip.hidePopup();
    		//tooltip.getElementById("hc-notifier-tooltip-title").setAttribute("value", "FHT " + aName[1]);
    		//tooltip.getElementById("hc-notifier-tooltip-temperature").setAttribute("value", szTemperature);
    		var cells = tooltip.getElementsByTagName("description");
    		//alert("Cells length: " + cells.length);
    		cells[0].setAttribute("value", "FHT " + aName[1]);
    		cells[2].setAttribute("value", szTemperature);
    		cells[4].setAttribute("value", szTarget);
    		cells[6].setAttribute("value", szPosition + " %");
    		cells[8].setAttribute("value", szMode);
			//for (var i = 0; i < cells.length; i++) { 
				//alert("
    			//status = cells[i].getAttribute("status"); 
			//}
		}
    	updateHeaterPosition(aElementId, szPosition, szLowBattery, szWindowOpen);	//, szLowBattery
    	//alert("parseRSSXML: Parsed for " + aElementId);
    }
    else
    {
	    alert("HS-Notifier - parseRSSXML: Element " + aElementId + "could not be retrieved");
    }    
}

function parseRSSXMLHMSRX(aItem, aElementId) {
	//alert("Start Parsing HMSRX RSS XML for " + aElementId);
	var aTitle = aItem.getElementsByTagName("title");
    var aDescriptions = aItem.getElementsByTagName("description");
    var aDate = aItem.getElementsByTagName("pubDate");
         
    var szName = aTitle[0].firstChild.nodeValue;
    var aName = szName.split(":");
    
    var szDesc = aDescriptions[0].firstChild.nodeValue;
    // Decode Blowfish encrypted content
    //var szDescDecoded = decode(szDesc);
    //alert("Decoded description: " + szDescDecoded);
    var aDesc = szDesc.split("|");

    var szTemp = aDesc[0];
    var aTemp = szTemp.split(":");
    var szTemperature = aTemp[1];

	var szMoist = aDesc[1];
    var aMoisture = szMoist.split(":");
    var szMoisture = aMoisture[1];

    //var update = aDate[0].firstChild.nodeValue;
    //var tooltipstring = "Last Updated: " + update + "\n Moisture: " + szMoisture + " %"; // + ": " + aDesc[3];

    //document.getElementById('my-panel-Salon').label = name + ": " + temperature + "/" + target; // innerText
    if (document.getElementById(aElementId)) {
	    if (document.getElementById(aElementId).collapsed == true)
	    	document.getElementById(aElementId).collapsed = false;	// make the element appear
      	document.getElementById(aElementId).setAttribute("label", aName[1] + ": " + szTemperature + "/" + szMoisture);

      	if (document.getElementById(aElementId).hasAttribute("tooltip")) {
			var tooltip = document.getElementById(document.getElementById(aElementId).getAttribute("tooltip"));

    		var cells = tooltip.getElementsByTagName("description");
    		cells[0].setAttribute("value", "HMSRX " + aName[1]);
    		cells[2].setAttribute("value", szTemperature);
    		cells[4].setAttribute("value", szMoisture);
		}
    	updateMoistureValue(aElementId, szMoisture);
    	//alert("parseRSSXML: Parsed for " + aElementId);
    }
    else
    {
	    alert("HS-Notifier - parseRSSXML: Element " + aElementId + "could not be retrieved");
    }    
}

function parseRSSXMLFS20TX(aItem, aElementId) {
	//alert("Start Parsing FS20TX RSS XML for " + aElementId);
	var aTitle = aItem.getElementsByTagName("title");
    var aDescriptions = aItem.getElementsByTagName("description");
    var aDate = aItem.getElementsByTagName("pubDate");
         
    var szName = aTitle[0].firstChild.nodeValue;
    var aName = szName.split(":");
    
    var szDesc = aDescriptions[0].firstChild.nodeValue;
    // Decode Blowfish encrypted content
    //var szDescDecoded = decode(szDesc);
    //alert("Decoded description: " + szDescDecoded);
    var aDesc = szDesc.split("|");

    var szStat = aDesc[0];
    var aStat = szStat.split(":");
    var szStatus = aStat[1];

    //var update = aDate[0].firstChild.nodeValue;
    //var tooltipstring = "Last Updated: " + update + "\n Moisture: " + szMoisture + " %"; // + ": " + aDesc[3];

    //document.getElementById('my-panel-Salon').label = name + ": " + temperature + "/" + target; // innerText
    if (document.getElementById(aElementId)) {
	    if (document.getElementById(aElementId).collapsed == true)
	    	document.getElementById(aElementId).collapsed = false;	// make the element appear
	    	
	    document.getElementById(aElementId).setAttribute("label", aName[1]);
	    
	    if (szStatus == " 1") {	
	    	document.getElementById(aElementId).setAttribute("bulb_on", "true");
    	} else {
	    	document.getElementById(aElementId).setAttribute("bulb_on", "false");
    	}

      	//if (document.getElementById(aElementId).hasAttribute("tooltip")) {
		//	var tooltip = document.getElementById(document.getElementById(aElementId).getAttribute("tooltip"));
		//
    	//	var cells = tooltip.getElementsByTagName("description");
    	//	cells[0].setAttribute("value", "HMSRX " + aName[1]);
    	//	cells[2].setAttribute("value", szTemperature);
    	//	cells[4].setAttribute("value", szMoisture);
		//}
    	//updateMoistureValue(aElementId, szMoisture);
    	//alert("parseRSSXML: Parsed for " + aElementId);
    }
    else
    {
	    alert("HS-Notifier - parseRSSXML: Element " + aElementId + "could not be retrieved");
    }    
}



function parseRSSXMLISDN(aItem) {
	// Calls
     var descriptions = aItem.getElementsByTagName("description");
     var date = aItem.getElementsByTagName("pubDate");
     
     var desc = descriptions[0].firstChild.nodeValue;
     var descarray = desc.split("|");

     var nc = descarray[0];
     var newcallsarray = nc.split(":");
     var newcalls = newcallsarray[1];

     var msg = descarray[1];
     var msgarray = msg.split(":");
     var newmessages = msgarray[1];
     
     var szUpdate = date[0].firstChild.nodeValue;

     // Fill the tooltip
     //tooltipstring = newcalls + " new Calls ( " + newmessages + " Messages )";
     if (document.getElementById('callsButton').hasAttribute("tooltip")) {
			var tooltip = document.getElementById(document.getElementById('callsButton').getAttribute("tooltip"));
    		//tooltip.hidePopup();
    		//tooltip.getElementById("hc-notifier-tooltip-title").setAttribute("value", "FHT " + aName[1]);
    		//tooltip.getElementById("hc-notifier-tooltip-temperature").setAttribute("value", szTemperature);
    		var cells = tooltip.getElementsByTagName("description");
    		//alert("Cells length: " + cells.length);
    		cells[0].setAttribute("value", newcalls + " new Calls ( " + newmessages + " Messages )");
    		cells[2].setAttribute("value", szUpdate);
			//for (var i = 0; i < cells.length; i++) { 
				//alert("
    			//status = cells[i].getAttribute("status"); 
			//}
		}
     
     //alert(newcalls + "(" + newmessages + ")");

     if (newcalls > 0) {
        //alert("Set newcalls true"); 
     	setNewCalls(true);
 	 }
 	 else
 	 {
     	setNewCalls(false);
 	 }
     //document.getElementById('callsButton').tooltipText = tooltipstring;
}

function fillInTooltip(aTooltipElement) {
	// Called when the tooltip popup is opened
}

function decode(szEncoded) {
	// Requires securesyndication.js
    var context = new BlowfishCtx();
	blowfish_init(context, "TEST");	// keys[div_content[0]]
    szDecoded = decrypt_string(context, szEncoded);
    
    return szDecoded;
}
         
function updateStatusBarPosition() {

  var statusBar = document.getElementById("status-bar");
  var children = statusBar.childNodes;

  var statusbarItem = document.getElementById("callsButton");
  var newStatusbarItem = statusBar.removeChild(statusbarItem);

  if ((children.length == 0) || (index >= children.length))
    statusBar.appendChild(newStatusbarItem);
  else
    statusBar.insertBefore(newStatusbarItem, children[index-1]);
}

function hideAllItems() {
	var myStatusBar = document.getElementById("statusbox-fht");
	var sbCells = myStatusBar.getElementsByTagName("statusbarpanel");
	//alert("Cells length: " + sbCells.length);
	for (var i = 0; i < sbCells.length; i++) {
		//alert("sbCells [" + i + "] nID: " + sbCells[i].id);
    	if (sbCells[i].id != "callsButton") {
    		if (sbCells[i].collapsed == false)
	    		sbCells[i].collapsed = true;	// make the element disapear
	    } 
    }
}

function showError(szError) {
	//alert("I am in the error");
	hideAllItems();
    var item = document.getElementById("hsn-error");
   	if (item) {
	    if (item.collapsed == true)
	    	item.collapsed = false;	// make the Error element appear
	    item.setAttribute("label", szError); 
	    item.parentNode.setAttribute("selectedIndex", "1");
    }
}

function hideError() {
	var item = document.getElementById("hsn-error");
	if (item) {
	    if (item.collapsed == false)
	    	item.collapsed = true;	// make the Error element disappear
	    item.setAttribute("label", ""); 
	}
}

function showProgress() {
    var item = document.getElementById("hsn-progress");   
    
    //set progress
    item.removeAttribute("value");
    item.setAttribute("mode", "undetermined");
    item.setAttribute("tooltiptext", "Loading");    
    
    //show panel
    item.setAttribute("collapsed","false");
    item.parentNode.setAttribute("selectedIndex", "2");  
}

function hideProgress() {
    var item = document.getElementById("hsn-progress");
    
    //remove progress
    item.setAttribute("mode", "determined");
    item.setAttribute("value", "0");
    item.setAttribute("collapsed", "true");
}

function showPanel() {
	//show panel
    var deck = document.getElementById("statusdeck");
    deck.setAttribute("selectedIndex", "0");
}


// From http://www.captain.at/howto-firefox-statusbar-tutorial.php
function makeRequest(url, parameters) {
   //alert("homecontrolOverlay.js: In Request");
   http_request = false;
   http_request = new XMLHttpRequest();
   if (http_request.overrideMimeType) {
      http_request.overrideMimeType('text/xml');
   }
   if (!http_request) {
      //alert('HS-Notifier: Cannot create XMLHTTP instance');
      hideProgress();
      showError("Home Status Notifier Error: Cannot create connection");
      return false;
   }
   http_request.onreadystatechange = alertContents;
   http_request.open('GET', url + parameters, true); // AJAX
   http_request.send(null);
}

// From http://www.captain.at/howto-firefox-statusbar-tutorial.php
function alertContents() {
   //alert("homecontrolOverlay.js: In alertContents");
   if (http_request.readyState == 4) {
      if (http_request.status == 200) {

         var xmlobject = http_request.responseXML;
         var root = xmlobject.getElementsByTagName('rss')[0];
         var channels = root.getElementsByTagName("channel");
         var rsslink = root.getElementsByTagName("link")[0].firstChild.nodeValue;
	     var items = channels[0].getElementsByTagName("item");
	     
	     // Provisory: set the shortcut from the general Feed Link
	     wm_prefs.setCharPref(wm_prefs.PREF_SHORTCUT_URL, rsslink);
	     
		 // Get the bit-coded index of Modules to be shown
	     var nModulesToShowBits = wm_prefs.getIntPref(wm_prefs.PREF_MODULES_TO_SHOW);
	     //alert("homecontrolOverlay.js: wm_prefs.PREF_MODULES_TO_SHOW = " + nModulesToShowBits);
	     
	     // The maximum statusbar panels for FHTs we have available
	     var myfhts = new Array("my-fhtpanel0",
	     						"my-fhtpanel1",
	     						"my-fhtpanel2",
	     						"my-fhtpanel3",
	     						"my-fhtpanel4",
	     						"my-fhtpanel5",
	     						"my-fhtpanel6",
	     						"my-fhtpanel7",
	     						"my-fhtpanel8",
	     						"my-fhtpanel9");

	     var myhmss = new Array("my-hmspanel0",
	     						"my-hmspanel1");
	     						
	     var myfs20tx = new Array("my-fs20txpanel0",
	     						  "my-fs20txpanel1",
	     						  "my-fs20txpanel2");
	     
	     var nNbOfFHTs = 0;
	     var nNbOfHMSs = 0;
	     var nNbOfFS20TXs = 0;
	     // We disable the calls button (replaced by info button) before getting the feed
	     enableCalls(false);
	     // We collapse all statusbar items
	     hideAllItems();

	     var nItemIndex = 0;
	     // Loop on Items in the RSS XML File
	     for (nItemIndex = 0; nItemIndex < items.length; nItemIndex++) {
		    // The Mask to extract the bits for the Modules to be shown index
		    var nMask = 1 << nItemIndex;
		
		    var szModule = checkModuleType(items[nItemIndex]); 
		    //alert("nItemIndex: " + nItemIndex + " - szModule: " + szModule + " - nNbOfFHTs: " + nNbOfFHTs);
	     	if ((szModule == "FHT") && (nNbOfFHTs < myfhts.length) && ((nModulesToShowBits & nMask) == nMask)) {
		     	parseRSSXMLFHT(items[nItemIndex], myfhts[nNbOfFHTs]);
		     	nNbOfFHTs++;
	     	}
	     	if ((szModule == "HMSRX") && (nNbOfHMSs < myhmss.length) && ((nModulesToShowBits & nMask) == nMask)) {
		     	parseRSSXMLHMSRX(items[nItemIndex], myhmss[nNbOfHMSs]);
		     	nNbOfHMSs++;
	     	}
	     	if ((szModule == "FS20TX" || szModule == "FS20RX") && (nNbOfFS20TXs < myfs20tx.length) && ((nModulesToShowBits & nMask) == nMask)) {
	     		parseRSSXMLFS20TX(items[nItemIndex], myfs20tx[nNbOfFS20TXs]);
	     		nNbOfFS20TXs++;
     		}
	        if ((szModule == "ISDN")) {	//  && ((nModulesToShowBits & nMask) == nMask)
		        // We found a ISDN entry in the feed, we enable the calls button
		        enableCalls(true);
		        parseRSSXMLISDN(items[nItemIndex],'callsButton'); 
	        }
         }
         //hideProgress();
   		 //showPanel();
      } else {
         //alert('Home Control Notifier: There was a problem with the request.');
         hideProgress();
         showError("Home Status Notifier Error: Problem connecting to the RSS Feed");
      }
   } else {
	   //alert("Request State " + http_request.readyState);
	   // 0 (uninitialized)
       // 1 (loading)
       // 2 (loaded)
       // 3 (interactive)
       // 4 (complete) 
   }
}

/**
 * Gets called when a notifier preference changes
 *
 * @param aPrefName - string containing the name of the preference that was changed
 */
function preferencesChanged(aPrefName) {
	//alert("homecontrolOverlay.js -> preference " + aPrefName + " changed !");
	updatevariables();
    //switch(aPrefName){
    //  case wm_prefs.PREF_STATUSBAR_ENABLED:
    //  showStatusbarItem();
    //  break;
    //}
}

// From http://www.captain.at/howto-firefox-statusbar-tutorial.php
function updatevariables() {
   hideError();
 	
   var szRSSFeedURL = wm_prefs.getCharPref(wm_prefs.PREF_RSS_URL);

   //alert("RSS Feed URL: " + szRSSFeedURL);
   if (szRSSFeedURL != null) {
	   showProgress();
	   makeRequest(szRSSFeedURL, '');
	   hideProgress();
	   showPanel();
   } else {
	   alert("Home Control Notifier: \n RSS Feed URL not defined. Open the Preferences dialog with a right-click on the Status Bar Icon and set the RSS Feed URL");
	   //hideProgress();
	   showError("Home Status Notifier Error: RSS Feed URL not defined");
   }
   
   //alert("homecontrolOverlay.js -> Variable Updated - TimeOut: " + nUpdateInterval);
   var nUpdateInterval = wm_prefs.getIntPref(wm_prefs.PREF_UPDATE_INTERVAL)*60*1000;
   self.setTimeout('updatevariables()', nUpdateInterval);
   
   //updateStatusBarPosition();
}

function browserstartup() {
	//alert('homecontrolOverlay.js -> Startup');

	updatevariables();
	
	window.removeEventListener("load", browserstartup, false);
}

function browsershutdown() {
	// remove the preferences observer
  	if (wm_prefs)
    	wm_prefs.removeObserver("homecontrol", PrefChangeObserver);
}


// From http://www.captain.at/howto-firefox-statusbar-tutorial.php
window.addEventListener("load", browserstartup, false);
window.addEventListener("unload", browsershutdown, false);